package com.fp.persistence.pgeneral.score;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que hace referencia a la Clave Primaria de TGENEACCOUNTSCORE*/
@Embeddable
public class TgeneAccountScoreKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="ACCOUNT", nullable=false,updatable=false)

/**
* Numero de cuenta
*/
private String account;

@Column(name="COMPANY", nullable=false,updatable=false)

/**
* Codigo de compania a la que pertence la cuenta
*/
private Integer company;

@Column(name="SCOREDATE", nullable=false,updatable=false)

/**
* Fecha de calificacion de la cuenta
*/
private Date scoredate;

/**Contructor por defecto*/
public TgeneAccountScoreKey(){}
/**Contructor de TgeneAccountScoreKey
@param pAccount Numero de cuenta
@param pCompany Codigo de compania a la que pertence la cuenta
@param pScoredate Fecha de calificacion de la cuenta
*/
public TgeneAccountScoreKey(String pAccount,Integer pCompany,Date pScoredate){
 account=pAccount;
 company=pCompany;
 scoredate=pScoredate;
}
/**Obtiene el valor de account
@return valor de account*/
public String getAccount(){
  return account;
}
/**Fija el valor de account
@param pAccount nuevo Valor de account*/
public void setAccount(String pAccount){
  account=pAccount;
}

/**Obtiene el valor de company
@return valor de company*/
public Integer getCompany(){
  return company;
}
/**Fija el valor de company
@param pCompany nuevo Valor de company*/
public void setCompany(Integer pCompany){
  company=pCompany;
}

/**Obtiene el valor de scoredate
@return valor de scoredate*/
public Date getScoredate(){
  return scoredate;
}
/**Fija el valor de scoredate
@param pScoredate nuevo Valor de scoredate*/
public void setScoredate(Date pScoredate){
  scoredate=pScoredate;
}

/**Implementacion de la comparacion de TgeneAccountScoreKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneAccountScoreKey))return false;
  TgeneAccountScoreKey that = (TgeneAccountScoreKey) o;
  if (this.getAccount() == null || that.getAccount() == null){
      return false;
  }
  if (! this.getAccount().equals(that.getAccount())){
    return false;
  }
  if (this.getCompany() == null || that.getCompany() == null){
      return false;
  }
  if (! this.getCompany().equals(that.getCompany())){
    return false;
  }
  if (this.getScoredate() == null || that.getScoredate() == null){
      return false;
  }
  if (! this.getScoredate().equals(that.getScoredate())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TgeneAccountScoreKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getAccount() == null ? 0 : this.getAccount().hashCode());
    result = result * 37 + (this.getCompany() == null ? 0 : this.getCompany().hashCode());
    result = result * 37 + (this.getScoredate() == null ? 0 : this.getScoredate().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
